# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from mtmaisdk.clients.rest.models.api_resource_meta import APIResourceMeta
from typing import Optional, Set
from typing_extensions import Self

class TenantAlertingSettings(BaseModel):
    """
    TenantAlertingSettings
    """ # noqa: E501
    metadata: APIResourceMeta
    alert_member_emails: Optional[StrictBool] = Field(default=None, description="Whether to alert tenant members.", alias="alertMemberEmails")
    enable_workflow_run_failure_alerts: Optional[StrictBool] = Field(default=None, description="Whether to send alerts when workflow runs fail.", alias="enableWorkflowRunFailureAlerts")
    enable_expiring_token_alerts: Optional[StrictBool] = Field(default=None, description="Whether to enable alerts when tokens are approaching expiration.", alias="enableExpiringTokenAlerts")
    enable_tenant_resource_limit_alerts: Optional[StrictBool] = Field(default=None, description="Whether to enable alerts when tenant resources are approaching limits.", alias="enableTenantResourceLimitAlerts")
    max_alerting_frequency: StrictStr = Field(description="The max frequency at which to alert.", alias="maxAlertingFrequency")
    last_alerted_at: Optional[datetime] = Field(default=None, description="The last time an alert was sent.", alias="lastAlertedAt")
    __properties: ClassVar[List[str]] = ["metadata", "alertMemberEmails", "enableWorkflowRunFailureAlerts", "enableExpiringTokenAlerts", "enableTenantResourceLimitAlerts", "maxAlertingFrequency", "lastAlertedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TenantAlertingSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TenantAlertingSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "metadata": APIResourceMeta.from_dict(obj["metadata"]) if obj.get("metadata") is not None else None,
            "alertMemberEmails": obj.get("alertMemberEmails"),
            "enableWorkflowRunFailureAlerts": obj.get("enableWorkflowRunFailureAlerts"),
            "enableExpiringTokenAlerts": obj.get("enableExpiringTokenAlerts"),
            "enableTenantResourceLimitAlerts": obj.get("enableTenantResourceLimitAlerts"),
            "maxAlertingFrequency": obj.get("maxAlertingFrequency"),
            "lastAlertedAt": obj.get("lastAlertedAt")
        })
        return _obj


